%global debug_package %{nil}

Name:           dnsproxy
Version:        0.75.5
Release:        1%{?dist}
Summary:        Simple DNS proxy with DoH, DoT, DoQ and DNSCrypt support
License:        Apache-2.0
URL:            https://github.com/AdguardTeam/dnsproxy
Packager:       Teddysun <i@teddysun.com>

Source0:        https://github.com/AdguardTeam/dnsproxy/archive/refs/tags/v%{version}.tar.gz#/dnsproxy-%{version}.tar.gz
Source1:        https://github.com/AdguardTeam/dnsproxy/raw/master/config.yaml.dist
Requires:       libcap

%description
A simple DNS proxy server that supports all existing DNS protocols including
DNS-over-TLS, DNS-over-HTTPS, DNSCrypt, and DNS-over-QUIC.
Moreover, it can work as a DNS-over-HTTPS, DNS-over-TLS or DNS-over-QUIC server.

%prep
%setup -q -n %{name}-%{version}

%build
# https://pagure.io/go-rpm-macros/c/1cc7f5d9026175bb6cb1b8c889355d0c4fc0e40a
%undefine _auto_set_build_flags

LDFLAGS="-X github.com/AdguardTeam/dnsproxy/internal/version.version=v%{version} -s -w -buildid="
env CGO_ENABLED=0 go build -v -trimpath -ldflags "${LDFLAGS}" -o %{name}

%install
%{__install} -d %{buildroot}%{_bindir}
%{__install} -p -m 755 %{name} %{buildroot}%{_bindir}
# config
%{__install} -D -p -m 0644 %{S:1} %{buildroot}%{_sysconfdir}/%{name}/config.yaml
%{__install} -d %{buildroot}%{_unitdir}
cat > %{buildroot}%{_unitdir}/%{name}.service <<EOF
[Unit]
Description=dnsproxy service
Documentation=https://github.com/AdguardTeam/dnsproxy
After=network.target

[Service]
CapabilityBoundingSet=CAP_NET_BIND_SERVICE
AmbientCapabilities=CAP_NET_BIND_SERVICE
ExecStart=/usr/bin/dnsproxy --config-path=/etc/dnsproxy/config.yaml
Restart=on-failure
LimitNPROC=10000
LimitNOFILE=1000000

[Install]
WantedBy=multi-user.target
EOF

%post
%systemd_post %{name}.service
setcap cap_net_bind_service=+eip %{_bindir}/%{name}

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files
%{_bindir}/%{name}
%{_unitdir}/%{name}.service
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/config.yaml
%license LICENSE
%doc README.md

%changelog
* Wed May 14 2025 Teddysun <i@teddysun.com> - 0.75.5-1
- Update version to 0.75.5

* Wed May 07 2025 Teddysun <i@teddysun.com> - 0.75.4-1
- Update version to 0.75.4

* Fri Apr 18 2025 Teddysun <i@teddysun.com> - 0.75.3-1
- Update version to 0.75.3

* Thu Mar 20 2025 Teddysun <i@teddysun.com> - 0.75.2-1
- Update version to 0.75.2

* Tue Mar 11 2025 Teddysun <i@teddysun.com> - 0.75.1-1
- Update version to 0.75.1

* Thu Jan 30 2025 Teddysun <i@teddysun.com> - 0.75.0-1
- Update version to 0.75.0

* Sat Dec 28 2024 Teddysun <i@teddysun.com> - 0.74.1-1
- Update version to 0.74.1

* Fri Dec 27 2024 Teddysun <i@teddysun.com> - 0.74.0-1
- Update version to 0.74.0

* Tue Dec 24 2024 Teddysun <i@teddysun.com> - 0.73.5-1
- Update version to 0.73.5

* Fri Nov 29 2024 Teddysun <i@teddysun.com> - 0.73.4-1
- Update version to 0.73.4

* Fri Nov 08 2024 Teddysun <i@teddysun.com> - 0.73.3-1
- Update version to 0.73.3

* Mon Sep 16 2024 Teddysun <i@teddysun.com> - 0.73.2-1
- Update version to 0.73.2

* Wed Aug 21 2024 Teddysun <i@teddysun.com> - 0.73.1-1
- Update version to 0.73.1

* Tue Aug 20 2024 Teddysun <i@teddysun.com> - 0.73.0-1
- Update version to 0.73.0

* Thu Aug 01 2024 Teddysun <i@teddysun.com> - 0.72.2-1
- Update version to 0.72.2

* Fri Jul 19 2024 Teddysun <i@teddysun.com> - 0.72.1-1
- Update version to 0.72.1

* Fri Jul 05 2024 Teddysun <i@teddysun.com> - 0.72.0-1
- Update version to 0.72.0

* Fri May 31 2024 Teddysun <i@teddysun.com> - 0.71.2-1
- Update version to 0.71.2

* Thu May 02 2024 Teddysun <i@teddysun.com> - 0.71.1-1
- Update version to 0.71.1

* Fri Apr 26 2024 Teddysun <i@teddysun.com> - 0.71.0-1
- Update version to 0.71.0

* Thu Apr 18 2024 Teddysun <i@teddysun.com> - 0.70.0-1
- Update version to 0.70.0

* Fri Apr 12 2024 Teddysun <i@teddysun.com> - 0.69.2-1
- Update version to 0.69.2

* Thu Apr 11 2024 Teddysun <i@teddysun.com> - 0.69.1-1
- Update version to 0.69.1

* Wed Apr 10 2024 Teddysun <i@teddysun.com> - 0.69.0-1
- Update version to 0.69.0

* Fri Apr 05 2024 Teddysun <i@teddysun.com> - 0.68.0-1
- Update version to 0.68.0

* Wed Apr 03 2024 Teddysun <i@teddysun.com> - 0.67.0-1
- Update version to 0.67.0

* Tue Apr 02 2024 Teddysun <i@teddysun.com> - 0.66.1-1
- Update version to 0.66.1

* Mon Mar 11 2024 Teddysun <i@teddysun.com> - 0.66.0-1
- Update version to 0.66.0

* Tue Feb 27 2024 Teddysun <i@teddysun.com> - 0.65.2-1
- Update version to 0.65.2

* Fri Feb 23 2024 Teddysun <i@teddysun.com> - 0.65.1-1
- Update version to 0.65.1

* Fri Feb 09 2024 Teddysun <i@teddysun.com> - 0.65.0-1
- Update version to 0.65.0

* Wed Jan 31 2024 Teddysun <i@teddysun.com> - 0.64.1-1
- Update version to 0.64.1

* Tue Jan 30 2024 Teddysun <i@teddysun.com> - 0.64.0-1
- Update version to 0.64.0

* Wed Jan 24 2024 Teddysun <i@teddysun.com> - 0.63.1-1
- Update version to 0.63.1

* Tue Jan 16 2024 Teddysun <i@teddysun.com> - 0.63.0-1
- Update version to 0.63.0

* Fri Jan 12 2024 Teddysun <i@teddysun.com> - 0.62.0-1
- Update version to 0.62.0

* Sat Dec 30 2023 Teddysun <i@teddysun.com> - 0.61.1-1
- Update version to 0.61.1

* Tue Dec 19 2023 Teddysun <i@teddysun.com> - 0.61.0-1
- Update version to 0.61.0

* Mon Dec 18 2023 Teddysun <i@teddysun.com> - 0.60.1-1
- Initial version 0.60.1
